SystemOrganization addCategory: #'BlackGold-Core'!

ALApplication subclass: #BGWikiApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGWikiApplication methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:47'!
initializeLocator
	locator 
		at: ALPath root 
		put: BGHomePage new asResource! !

Object subclass: #BGController
	instanceVariableNames: 'snapshot delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

BGController subclass: #BGComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGComponent methodsFor: 'as yet unclassified' stamp: 'chc 4/26/2017 10:05'!
renderContentOn: anObject
	self subclassResponsibility ! !

BGComponent subclass: #BGCounter
	instanceVariableNames: 'count parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
count

	^ count! !

!BGCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
count: anObject

	count := anObject! !

!BGCounter methodsFor: 'as yet unclassified' stamp: 'chc 4/20/2017 09:16'!
initialize
	super initialize.
	count := 0.
	"delegate := BGHelloWorld new. "! !

!BGCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
parent

	^ parent! !

!BGCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
parent: anObject

	parent := anObject! !

!BGCounter methodsFor: 'as yet unclassified' stamp: 'chc 4/21/2017 08:55'!
renderContentOn: html
	html a navigate: [count := count + 1]; with: '++'.
	html br.
	html span with: count asString.
	html br. 
	html a navigate: [count := count - 1]; with: '--'.
	html br.
	html a callback: [ parent main clearDelegate]; with: 'Answer And Return'! !

BGComponent subclass: #BGHelloMars
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHelloMars methodsFor: 'as yet unclassified' stamp: 'chc 4/20/2017 09:44'!
renderContentOn: html
	html p: 'Hello Mars'! !

BGComponent subclass: #BGHelloWorld
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 4/20/2017 09:51'!
initialize
	main := BGHelloMars new! !

!BGHelloWorld methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:55'!
main

	^ main! !

!BGHelloWorld methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:55'!
main: anObject

	main := anObject! !

!BGHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 4/21/2017 08:42'!
renderContentOn: html
	html div id: 'border'; with: [html p: 'Hello World'].
	html div id: 'border'; with: main.
	html a callback: [ main delegate: (BGCounter new parent: self)]; with: 'Next Delegate'! !

!BGController methodsFor: 'call/answer' stamp: 'chc 4/21/2017 08:59'!
call: aRenderable
	self delegate: (aRenderable new parent: self)! !

!BGController methodsFor: 'delegate' stamp: 'chc 4/21/2017 08:47'!
clearDelegate
	self delegate: nil! !

!BGController methodsFor: 'delegate' stamp: 'chc 4/21/2017 08:21'!
delegate

	^ delegate! !

!BGController methodsFor: 'delegate' stamp: 'chc 4/21/2017 08:21'!
delegate: anObject

	delegate := anObject! !

!BGController methodsFor: 'rendering' stamp: 'chc 4/20/2017 09:43'!
renderOn: html
	|del|
	del := delegate.
	del
		ifNil: [self renderContentOn: html]
		ifNotNil: [ delegate renderOn: html ]! !

!BGController methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:21'!
snapshot

	^ snapshot! !

!BGController methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:21'!
snapshot: anObject

	snapshot := anObject! !

Object subclass: #BGHomePage
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHomePage methodsFor: 'converting' stamp: 'chc 4/18/2017 15:06'!
asResource
	^ BGHtmlResource component: self! !

!BGHomePage methodsFor: 'initialize-release' stamp: 'chc 4/27/2017 10:01'!
initialize
	root := BGHelloWorld new! !

!BGHomePage methodsFor: 'rendering' stamp: 'chc 4/27/2017 10:01'!
renderBodyOn: html
	html div
		with: [root renderOn: html]! !

!BGHomePage methodsFor: 'rendering' stamp: 'chc 4/27/2017 10:01'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'BlackGold'.
			 html style: 
				'#border {
					border: thin solid #aaa;
					margin-left: 8px;
					margin-right: 8 px;}'].
	html body: [ self renderBodyOn: html ] ]! !

ALComponentResource subclass: #BGHtmlResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:49'!
handleGet: aRequest locator: aLocator
	| response |
	response := self respondHtmlLocator: aLocator.
	response vary: (ALStrings with: 'Accept').
	^ response! !

!BGHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:48'!
respondHtmlLocator: aLocator
	 ^ ALResponse 
		type: ALContentType html 
		callback: 
			[:out || context |
			context := ALRenderingContext resource: self locator: aLocator.
			component renderHtmlOn: (ALAppHtml5Canvas context: context stream: out)]! !
